﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using DslModeling = global::Microsoft.VisualStudio.Modeling;
using DslDesign = global::Microsoft.VisualStudio.Modeling.Design;
using DslDiagrams = global::Microsoft.VisualStudio.Modeling.Diagrams;

namespace Liekhus.Xaf.BusinessObjectDesigner
{
	/// <summary>
	/// Helper class used to create and initialize toolbox items for this DSL.
	/// </summary>
	/// <remarks>
	/// Double-derived class to allow easier code customization.
	/// </remarks>
	public partial class XAFBODToolboxHelper : XAFBODToolboxHelperBase 
	{
		/// <summary>
		/// Constructs a new XAFBODToolboxHelper.
		/// </summary>
		public XAFBODToolboxHelper(global::System.IServiceProvider serviceProvider)
			: base(serviceProvider) { }
	}
	
	/// <summary>
	/// Helper class used to create and initialize toolbox items for this DSL.
	/// </summary>
	public abstract class XAFBODToolboxHelperBase
	{
		/// <summary>
		/// Toolbox item filter string used to identify XAFBOD toolbox items.  
		/// </summary>
		/// <remarks>
		/// See the MSDN documentation for the ToolboxItemFilterAttribute class for more information on toolbox
		/// item filters.
		/// </remarks>
		public const string ToolboxFilterString = "XAFBOD.1.4";
		/// <summary>
		/// Toolbox item filter string used to identify RelationshipTool connector tool.
		/// </summary>
		public const string RelationshipToolFilterString = "RelationshipTool.1.4";
		/// <summary>
		/// Toolbox item filter string used to identify CommentConnection connector tool.
		/// </summary>
		public const string CommentConnectionFilterString = "CommentConnection.1.4";
		/// <summary>
		/// Toolbox item filter string used to identify SecurityRequirementConnectionTool connector tool.
		/// </summary>
		public const string SecurityRequirementConnectionToolFilterString = "SecurityRequirementConnectionTool.1.4";
		/// <summary>
		/// Toolbox item filter string used to identify ObjectRequirementConnectionTool connector tool.
		/// </summary>
		public const string ObjectRequirementConnectionToolFilterString = "ObjectRequirementConnectionTool.1.4";

		private global::System.IServiceProvider sp;
		
		/// <summary>
		/// Constructs a new XAFBODToolboxHelperBase.
		/// </summary>
		protected XAFBODToolboxHelperBase(global::System.IServiceProvider serviceProvider)
		{
			if(serviceProvider == null) throw new global::System.ArgumentNullException("serviceProvider");
			
			this.sp = serviceProvider;
		}
		
		/// <summary>
		/// Serivce provider used to access services from the hosting environment.
		/// </summary>
		protected global::System.IServiceProvider ServiceProvider
		{
			get
			{
				return this.sp;
			}
		}

		/// <summary>
		/// Returns the display name of the tab that should be opened by default when the editor is opened.
		/// </summary>
		public static string DefaultToolboxTabName
		{
			get
			{
				return global::Liekhus.Xaf.BusinessObjectDesigner.XAFBODDomainModel.SingletonResourceManager.GetString("Business ObjectsToolboxTab", global::System.Globalization.CultureInfo.CurrentUICulture);
			}
		}
		
		
		/// <summary>
		/// Returns the toolbox items count in the default tool box tab.
		/// </summary>
		public static int DefaultToolboxTabToolboxItemsCount
		{
			get
			{
				return 5;
			}
		}
		

		/// <summary>
		/// Returns a list of toolbox items for use with this DSL.
		/// </summary>
		public virtual global::System.Collections.Generic.IList<DslDesign::ModelingToolboxItem> CreateToolboxItems()
		{
			global::System.Collections.Generic.List<DslDesign::ModelingToolboxItem> toolboxItems = new global::System.Collections.Generic.List<DslDesign::ModelingToolboxItem>();
			
			// Create store and load domain models.
			using(DslModeling::Store store = new DslModeling::Store(this.ServiceProvider))
			{
				store.LoadDomainModels(typeof(DslDiagrams::CoreDesignSurfaceDomainModel),
					typeof(global::Liekhus.Xaf.BusinessObjectDesigner.XAFBODDomainModel));
				global::System.Resources.ResourceManager resourceManager = global::Liekhus.Xaf.BusinessObjectDesigner.XAFBODDomainModel.SingletonResourceManager;
				global::System.Globalization.CultureInfo resourceCulture = global::System.Globalization.CultureInfo.CurrentUICulture;
			
				// Open transaction so we can create model elements corresponding to toolbox items.
				using(DslModeling::Transaction t = store.TransactionManager.BeginTransaction("CreateToolboxItems"))
				{

					// Add DomainObjectTool shape tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"DomainObjectToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						1, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("DomainObjectToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("DomainObjectToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.
						"Business ObjectsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("Business ObjectsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"DomainObject", // F1 help keyword for the toolbox item.
						resourceManager.GetString("DomainObjectToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						CreateElementToolPrototype(store, global::Liekhus.Xaf.BusinessObjectDesigner.DomainObject.DomainClassId), // ElementGroupPrototype (data object) representing model element on the toolbox.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require) 
						}));

					// Add RelationshipTool connector tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"RelationshipToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						2, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("RelationshipToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("RelationshipToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.				
						"Business ObjectsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("Business ObjectsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"ConnectExampleRelationF1Keyword", // F1 help keyword for the toolbox item.
						resourceManager.GetString("RelationshipToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						null, // Connector toolbox items do not have an underlying data object.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require), 
							new global::System.ComponentModel.ToolboxItemFilterAttribute(RelationshipToolFilterString)
						}));

					// Add PropertyTool shape tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"PropertyToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						3, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("PropertyToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("PropertyToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.
						"Business ObjectsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("Business ObjectsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"PropertyTool", // F1 help keyword for the toolbox item.
						resourceManager.GetString("PropertyToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						CreateElementToolPrototype(store, global::Liekhus.Xaf.BusinessObjectDesigner.DomainProperty.DomainClassId), // ElementGroupPrototype (data object) representing model element on the toolbox.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require) 
						}));

					// Add CommentConnection connector tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"CommentConnectionToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						4, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("CommentConnectionToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("CommentConnectionToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.				
						"Business ObjectsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("Business ObjectsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"CommentConnection", // F1 help keyword for the toolbox item.
						resourceManager.GetString("CommentConnectionToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						null, // Connector toolbox items do not have an underlying data object.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require), 
							new global::System.ComponentModel.ToolboxItemFilterAttribute(CommentConnectionFilterString)
						}));

					// Add CommentTool shape tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"CommentToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						5, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("CommentToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("CommentToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.
						"Business ObjectsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("Business ObjectsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"Comment", // F1 help keyword for the toolbox item.
						resourceManager.GetString("CommentToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						CreateElementToolPrototype(store, global::Liekhus.Xaf.BusinessObjectDesigner.DomainComment.DomainClassId), // ElementGroupPrototype (data object) representing model element on the toolbox.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require) 
						}));

					// Add ActorTool shape tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"ActorToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						1, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("ActorToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("ActorToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.
						"RequirementsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("RequirementsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"Actor", // F1 help keyword for the toolbox item.
						resourceManager.GetString("ActorToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						CreateElementToolPrototype(store, global::Liekhus.Xaf.BusinessObjectDesigner.DomainUserContext.DomainClassId), // ElementGroupPrototype (data object) representing model element on the toolbox.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require) 
						}));

					// Add SecurityRequirementConnectionTool connector tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"SecurityRequirementConnectionToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						2, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("SecurityRequirementConnectionToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("SecurityRequirementConnectionToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.				
						"RequirementsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("RequirementsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"SecurityRequirementConnectionTool", // F1 help keyword for the toolbox item.
						resourceManager.GetString("SecurityRequirementConnectionToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						null, // Connector toolbox items do not have an underlying data object.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require), 
							new global::System.ComponentModel.ToolboxItemFilterAttribute(SecurityRequirementConnectionToolFilterString)
						}));

					// Add RequirementTool shape tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"RequirementToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						3, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("RequirementToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("RequirementToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.
						"RequirementsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("RequirementsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"RequirementTool", // F1 help keyword for the toolbox item.
						resourceManager.GetString("RequirementToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						CreateElementToolPrototype(store, global::Liekhus.Xaf.BusinessObjectDesigner.DomainRequirement.DomainClassId), // ElementGroupPrototype (data object) representing model element on the toolbox.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require) 
						}));

					// Add StepTool shape tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"StepToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						4, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("StepToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("StepToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.
						"RequirementsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("RequirementsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"StepTool", // F1 help keyword for the toolbox item.
						resourceManager.GetString("StepToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						CreateElementToolPrototype(store, global::Liekhus.Xaf.BusinessObjectDesigner.DomainRequirementAction.DomainClassId), // ElementGroupPrototype (data object) representing model element on the toolbox.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require) 
						}));

					// Add ObjectRequirementConnectionTool connector tool.
					toolboxItems.Add(new DslDesign::ModelingToolboxItem(
						"ObjectRequirementConnectionToolToolboxItem", // Unique identifier (non-localized) for the toolbox item.
						5, // Position relative to other items in the same toolbox tab.
						resourceManager.GetString("ObjectRequirementConnectionToolToolboxItem", resourceCulture), // Localized display name for the item.
						(global::System.Drawing.Bitmap)DslDiagrams::ImageHelper.GetImage(resourceManager.GetObject("ObjectRequirementConnectionToolToolboxBitmap", resourceCulture)), // Image displayed next to the toolbox item.				
						"RequirementsToolboxTab", // Unique identifier (non-localized) for the toolbox item tab.
						resourceManager.GetString("RequirementsToolboxTab", resourceCulture), // Localized display name for the toolbox tab.
						"ObjectRequirementConnectionTool", // F1 help keyword for the toolbox item.
						resourceManager.GetString("ObjectRequirementConnectionToolToolboxTooltip", resourceCulture), // Localized tooltip text for the toolbox item.
						null, // Connector toolbox items do not have an underlying data object.
						new global::System.ComponentModel.ToolboxItemFilterAttribute[] { // Collection of ToolboxItemFilterAttribute objects that determine visibility of the toolbox item.
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ToolboxFilterString, global::System.ComponentModel.ToolboxItemFilterType.Require), 
							new global::System.ComponentModel.ToolboxItemFilterAttribute(ObjectRequirementConnectionToolFilterString)
						}));

					t.Rollback();
				}
			}

			return toolboxItems;
		}
		
		/// <summary>
		/// Creates an ElementGroupPrototype for the element tool corresponding to the given domain class id.
		/// Default behavior is to create a prototype containing an instance of the domain class.
		/// Derived classes may override this to add additional information to the prototype.
		/// </summary>
		protected virtual DslModeling::ElementGroupPrototype CreateElementToolPrototype(DslModeling::Store store, global::System.Guid domainClassId)
		{
			DslModeling::ModelElement element = store.ElementFactory.CreateElement(domainClassId);
			DslModeling::ElementGroup elementGroup = new DslModeling::ElementGroup(store.DefaultPartition);
			elementGroup.AddGraph(element, true);
			return elementGroup.CreatePrototype();
		}
	}
}
