﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TextTemplating.VSHost;

namespace Liekhus.Xaf.BusinessObjectDesigner
{
    /// <summary>
    /// Partial class so that we can apply the custom attributes needed
    /// to register the custom tools.
    /// </summary>
    /// <remarks>
    /// The custom tool needs to be registered against each project system
    /// separately. Here we have two custom attributes, one for VB and
    /// one for C#.
    /// 
    /// The DSL setup package does not create the appropriate registry 
    /// entries to register the custom tools, so you need to customise
    /// the setup project to do this.
    /// 
    /// Running the regpkg tool with the appropriate command line 
    /// parameters will generate the necessary Wix or registry entries.
    /// </remarks>
    [ProvideCodeGenerator(typeof(XAFBODCustomTool), "XAFBODCustomTool", "Generates output directly from a Liekhus XAF model file", true, ProjectSystem = ProvideCodeGeneratorAttribute.CSharpProjectGuid)]
    //[ProvideCodeGenerator(typeof(XAFBODCustomTool), "XAFBODCustomTool", "Generates output directly from a Liekhus XAF model file", true, ProjectSystem = ProvideCodeGeneratorAttribute.VisualBasicProjectGuid)]
    partial class XAFBODDesignerPackage
    {
    }
}