﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.Shell.Interop;
using EnvDTE;

namespace Liekhus.Xaf.BusinessObjectDesigner
{
    internal partial class XAFBODEditorFactory : IVsEditorFactoryNotify
    {
        #region IVsEditorFactoryNotify Members

        int IVsEditorFactoryNotify.NotifyDependentItemSaved(IVsHierarchy pHier, uint itemidParent, string pszMkDocumentParent, uint itemidDpendent, string pszMkDocumentDependent)
        {
            return 0;
        }

        int IVsEditorFactoryNotify.NotifyItemAdded(uint grfEFN, IVsHierarchy pHier, uint itemid, string pszMkDocument)
        {
            object itemObject;
            int hr = pHier.GetProperty(itemid, (int)__VSHPROPID.VSHPROPID_ExtObject, out itemObject);
            if (hr < 0)
            {
                return hr;
            }

            ProjectItem item = itemObject as ProjectItem;
            if (item == null)
            {
                return -1;
            }

            // Place here the name of the custom tool you want to run

            item.Properties.Item("CustomTool").Value = "XAFBODCustomTool";

            return 0;
        }

        int IVsEditorFactoryNotify.NotifyItemRenamed(IVsHierarchy pHier, uint itemid, string pszMkDocumentOld, string pszMkDocumentNew)
        {
            return 0;
        }

        #endregion
    }
}
